;; --------------------------------------------------------------------------
db "$Id: detpack.inc,v 1.21 2008/05/15 21:12:21 Ralph Exp $"
;;
;; $Log: detpack.inc,v $
;; Revision 1.21  2008/05/15 21:12:21  Ralph
;; MicroXor added
;;
;; Revision 1.20  2006/03/20 21:37:20  ralph
;; added CVS keyword
;;
;; Revision 1.19  2006/03/20 21:18:01  ralph
;; added ExePack 3.69 and 4.05 according to Borg No. One
;;
;; Revision 1.18  2006/03/14 20:32:26  ralph
;; added rjcrush 1.x and TraceLock 0.9
;;
;; Revision 1.17  2006/03/13 22:10:49  ralph
;; added unknown protectors provided by Borg No. One
;; ------------------------------------------------------------------------
;; Revision 1.16  2002/06/25 20:22:06  ralph
;; Crypt 1.3/Dismember added.
;;
;; Revision 1.15  2002/05/26 18:55:04  ralph
;; Added AXE and RERP (unROSE 0.61)
;;
;; Revision 1.14  2002/05/16 17:17:09  ralph
;; unROSE 0.60 - added more than 10 new packers/detection.
;;
;; Revision 1.13  2002/05/14 16:19:15  ralph
;; UNROSE 0.55 now aborts if it find an packer that is know to be not unpackable!
;;
;; Revision 1.12  2002/05/13 18:24:29  ralph
;; unROSE 0.54: Added NOP tracer/detection
;; Added: DeepCrypt,  ComCyrpt and Crypt/Dismember
;;
;; Revision 1.11  2002/04/25 17:42:58  ralph
;; Added LZEXE (modified), unROSE 0.53
;;
;; Revision 1.10  2002/04/15 09:42:45  ralph
;; unROSE 0.52 - added packer/cryptor defenitions provided by BarinCast@aol.com
;;
;; Revision 1.9  2002/04/14 09:31:29  ralph
;; Unrose 0.51
;;
;; Revision 1.8  2002/04/09 21:38:24  ralph
;; Replaced Header with ID (for WinCVS)
;;
;; Revision 1.7  2002/04/09 21:28:08  ralph
;; Added Wumpus.cr and Alis by Manticore
;; Added Call detection
;;
;; Revision 1.6  2002/03/14 22:14:47  ralph
;; renamed DOC to TXT. ANSI to OEM converted
;;
;; Revision 1.3  2002/03/12 19:35:23  ralph
;; Added CVS Header
;;
;; Compiler:            TASM, ideal mode
;;
;; (C)opyright by ROSE SWE, Dipl.-Ing. Ralph Roth, http://come.to/rose_swe
;; All Rights Reserved!
;;
;; --------------------------------------------------------------------------


;; Assumes EP of host in ax:cx

;; I release this source code, because I hope someone will help me in adding
;; more protector/packer signatures.....

;; BTW this is not optimised for size, but who cares :-))

proc ChkPackType

      PUSHAD
push     es

;;    mov   [word ptr cs:start], ax     ; Anti Vandalen Trick
;;    mov   [word ptr cs:start+1], ax   ; Anti Vandalen Trick

      ; get son's segment
      push cs
      pop es
      lea bx, [param_block]    ; ptr on parameter block

      ; to lauch the son, we use an iret instruction. So we must first push
      ; the 3 parameters (CS, IP and flags) on the stack.

      mov    ax, [word es:bx+14h]    ; CS in cx
      mov    bx, [word es:bx+12h]    ; IP in ax
      push      ax
      pop       es


@@ChkPackers:
        PRINT   SigAtEP
        mov     ax, [word es:bx+2]
        Call    WriteHexa16
        mov     ax, [word es:bx]
        Call    WriteHexa16
        PRINT   HexCarReturn

        call    CheckPackerDB

        cmp     [dword es:bx], 6a406a42h
        jz      @@Kleebauer

        cmp     [dword es:bx], 5e0000e8h
        jnz     @@not_wwpmut
        cmp     [dword es:bx+4], 0ea83d68bh
        jnz     @@not_wwpmut
        Print   WWPMutaFound
        jmp     @@ok1

@@not_wwpmut:

        cmp     [byte es:bx+3], 81h
        jnz     @not_wwpmut11
        cmp     [byte es:bx+7], 2eh
        jnz     @not_wwpmut11
        cmp     [byte es:bx+8], 80h
        jnz     @not_wwpmut11
        cmp     [byte es:bx+16], 75h
        jnz     @not_wwpmut11
        cmp     [byte es:bx+17], 0f5h
        jnz     @not_wwpmut11

        Print   WWPMutaFound11
        jmp     @@ok1

@not_wwpmut11:
        cmp     [byte es:bx+8], 2eh
        jnz     @not_wwpmut11b
        cmp     [byte es:bx+9], 080h
        jnz     @not_wwpmut11b
        cmp     [byte es:bx+12], 00h
        jnz     @not_wwpmut11b
        cmp     [byte es:bx+17], 75h
        jnz     @not_wwpmut11b
        cmp     [byte es:bx+18], 0f5h
        jnz     @not_wwpmut11b

        Print   WWPMutaFound11
        jmp     @@ok1

@not_wwpmut11b:
        mov     esi, [Dword es:bx+10]
        and     esi, 0ffffffh
        cmp     esi, 0ed81cdh           ;; wwpack pr
        jz      @@ok_pr

        mov     esi, [Dword es:bx]
        cmp     esi, 0bf010dbeh
        jz      @@ok_apack
        cmp     esi, 01f0e1e50h
        jz      @@ucexe                 ;; UCEXE 2.2,2.3 (looks like apack)
;--------------------------------------------------------------------
        and     esi, 0f0ffffffh
        cmp     esi, 0c08c061eh
        jz      @@ok_apack              ;; apack, 06-02-2001
        cmp     [dword es:bx + 0eh], 0a4f357fch
        jz      @@ok_apack              ;; apack 0.98 -t, 08-08-2001

        cmp     [dword es:bx+3], 0d003ca8ch ;; p/pu
        jz      @@ok                    ;;;

        cmp     [dword es:bx], 01f0e1e50h ;; avpack
        jz      @@avpack
        cmp     [dword es:bx+14h], 01603da8ch ;; avpack
        jz      @@avpack

        cmp     [dword es:bx+24h], 0d38ce0d3h ;; AInexe 2.2
        jz      @@ainexe

        cmp     [dword es:bx+0bah], 08efac88ch ;; CryptLs 1.21
        jz      @@cryptls
        cmp     [dword es:bx+0cdh], 08efac88ch ;; CryptLs 1.20
        jz      @@cryptls
        cmp     [dword es:bx+00ah], 0e883c88ch ;; CryptLs 1.15
        jz      @@cryptls

        cmp     [dword es:bx], 025589c9ch ;; ProtEXE 2.11
        jz      @@protexe

        cmp     [dword es:bx], 00e061efch ;; LGLZ.Exe
        jz      @@lglz
        cmp     [dword es:bx+3], 01972fc3bh ;; LGLZ.Com
        jz      @@lglz

        cmp     [dword es:bx], 04f4f5f54h ;; Netrun? 3.00, IceUnp
        jz      @@NetRun
        cmp     [dword es:bx], 050505058h ;; Netrun? 3.00, Original
        jz      @@NetRun

        cmp     [dword es:bx], 08c061efch ;; ComprExe 1.00
        jz      @@ComprExe

;; -------- UPX 0.70? -- 10-Aug-1999 ------

        cmp     [dword es:bx+6], 0fdffc0bfh ;; UPX 0.70
        jz      @@UPX
        cmp     [dword es:bx+10], 080b5a91eh ;; UPX 0.70
        jz      @@UPX
;; ------- UPX 1.20 -- 06-Aug-2001 --------
        cmp     [dword es:bx+14h], 0fca4f3fdh ;; UPX 1.20, COM
        jz      @@UPX1
        cmp     [dword es:bx+18h], 0fca5f3fdh ;; UPX 1.20, EXE
        jz      @@UPX1

        cmp     [dword es:bx], 09c9001ebh ;; Elite.COM
        jnz     no_eliteCom
        cmp     [dword es:bx+4], 0fd601e06h ;; Elite.COM
        jz      @@EliteCOM

no_eliteCom:
        cmp     [dword es:bx], 04d4f5845h ;; EXOM
        jz      @@ok_exom

;       cmp     [byte es:bx], 0b9h
;       jnz     noRecS
;       cmp     [dword es:bx+3], 0c083d88ch
;       jz      @@ok1                   ;; RecSmall 1.05, 23-Aug-2001

noRecS:
        call    ChkProtect
        jz      @@ProtFound
        call    ChkPklite
        jz      @@PKliteFound

;; -------- Last try: COM file? ----------

nop_looper:
        cmp     [byte es:bx], 090h      ;; COMi with NOP?  rar 13.05.2002 - plasmoid dc!
        jnz     no_nop
        inc     bx
        jmp     nop_looper

no_nop:
        cmp     [byte es:bx], 0e9h      ;; COMi with Jump?
        jnz     @@tryCall

        add     bx, [word es:bx+1]      ;; Jump offset
        add     bx, 3
        jmp     @@ChkPackers

@@trycall:
        cmp     [byte es:bx], 0e8h      ;; COMi with Call?
        jnz     @@ErrNotFound

        add     bx, [word es:bx+1]      ;; Jump offset
        add     bx, 3
        jmp     @@ChkPackers

@@ErrNotFound:
        PRINT   TryGeneric

        mov     ax, 0c01h               ;;      @FlushKeyB
        int     21h

        push    ax
        PRINT   CarReturn
        pop     ax

        cmp     al, 'y'
        jz      @@ok1
        cmp     al, 'Y'
        jz      @@ok1
        ERROR   NotPacked, 2

;;;------------------------------------------------------------------
TryGeneric db   " ! NO known packer found. Shall I generic unpack this file?", 7, 13, 10
           db   " ? This could be dangerous and corrupt the file. Unpack? (y(z)/N)? ", "$"
SigAtEP   db    " ! Signature found at resolved entry point is = 0$"
NotPacked db    " Not packed/relocated with a known packer!", 13, 10, 7, "$"
WWPackFound db  "  WWPack P/PU signature found!", 13, 10, "$"
WWPackPrFound db"  WWPack PR signature found!", 13, 10, "$"
AVPackFound db  "  AVPack 1.2x signature found!", 13, 10, "$"
AInExeFound db  "  AINExe 2.2 signature found!", 13, 10, "$"
ProtExEFound db "  ProtEXE 2.11 signature found!", 13, 10, "$"
CryptLSFound db "  CryptLS 1.15-1.21 by Lightshow signature found!", 13, 10, "$"
ProtectFound db "  Protect! COM/EXE 5.0-5.6 or 6.0/unAV signature found!", 13, 10, "$"
WWPMutaFound db "  WWPack Mutator 1.00 signature found!",13,10,"$"
WWPMutaFound11 db"  WWPack Mutator 1.10/1.10b signature found!",13,10,"$"
NetRunFound  db "  Netrun 3.00 signature found!",13,10,"$"
ComprExeFound db"  ComprExe 1.00 signature found!",13,10,"$"
PKLiteFound   db"  Generic [PKLITE] signature found!",13,10,"$"
LGLZFound     db"  LGLZ COM/EXE signature found!",13,10,"$"
UPXFound1     db"  UPX 0.7x, 0.80 signature found! Please use UPX -d itself for unpacking!",13,10,"$"
UPXFound2     db"  UPX 1.20 signature found! Please use UPX -d itself for unpacking!",13,10,"$"
apackfound    db"  APack 0.xx-0.99 COM/EXE signature found!",13,10,"$"
elitefound    db"  Elite.COM packer signature found!",13,10,"$"
exomfound     db"  EXOM 0.01-0.03 COM signature found!",13,10,"$"
ucexefound    db"  UCEXE 2.x signature found!",13,10,"$"
kleebauerfound db "  Text 2 ASCII by Herbert Kleebauer found! Use FS to unpack!", 13, 10, "$"

FoundProt db   0

;;;------------------------------------------------------------------
;;;  KNOWN PACKERS/PROTECTOR TABLE
;;;------------------------------------------------------------------
                      ;; 0 = Unpacker (unpackable), 1 = No Unpacker
                      ;;"123456789o123456789o123456789o", x
PackerDB        dd      850002e8h
                db      "VSS 1.0x by ROSE SWE$$$$$$$$$$", 0

                dd      60010068h
                db      "R-Crypt 0.9x by ROSE SWE$$$$$$", 0

                dd      570100bfh
                db      "CryptCOM by Nuke$$$$$$$$$$$$$$", 0

                dd      8000BFFCh
                db      "RUCC/386 by ROSE SWE$$$$$$$$$$", 1

                dd      5053455Bh
                db      "624 1.1 by ESP$$$$$$$$$$$$$$$$", 1

                dd      57f7875fh
                db      "WUMPUScr by MantiCore?$$$$$$$$", 1

                dd      1EFCfa9Ch
                db      "AlisSoft by MantiCore?$$$$$$$$", 0

                dd      0fd010068h
                db      "TPack 0.5 beta$$$$$$$$$$$$$$$$", 1

                dd      53555403h
                db      "WWPack 3.05b -p$$$$$$$$$$$$$$$", 1     ;; work of Stephan

                dd      8C0604B8h
                db      "SDW386 $$$$$$$$$$$$$$$$$$$$$$$", 1

                dd      0BD005B8h
                db      "XoReR 2.1a by Dr. No$$$$$$$$$$", 1

                dd      1930F9E9h
                db      "XoReR 2.1b by Dr. No$$$$$$$$$$", 1

                dd      0B96770BAh
                db      "CauseWay Compressor 3.32$$$$$$", 1

                dd      261F16FAh
                db      "Vacuum Runtime Cmp. by Fiber$$", 1

                dd      09CFC1F0Eh
                db      "CrackStop 1.0b / 1.01$$$$$$$$$", 1

                dd      0FFBB48B4h
                db      "Com2Txt.Tseng$$$$$$$$$$$$$$$$$", 1

                dd      25373F3Ah
                db      "UnPackStop v0.97$$$$$$$$$$$$$$", 1

                      ;;"123456789o123456789o123456789o", x
                dd      8b1f0e06h
                db      "LZ-EXE 0.90/0.91$$$$$$$$$$$$$$", 0
                dd      0e8b1f0eh
                db      "LZ-EXE 0.9x (modified/unk)$$$$", 0

;; 07.05.2002
                dd      83DA8C1Eh
                db      "Crypt 1.13/Dismember (1995)$$$", 1

                dd      0A31FCCB8h
                db      "ComCrypt/Suhman (in CrLite)$$$", 0

                dd      81e98b59h
                db      "DeepCryptor 0.1b (Plasmoid/C)$", 0     ; simple com cryptr, 13.05.2002

                dd      09eb9cf9h                               ;; 17.05.2002, rar
                db      "Diet 1.4x/1.45f (Teddy M.)$$$$", 0

                dd      01c88cfch
                db      "ExeLite 1.00betaF (1994)$$$$$$", 0

                dd      1005c08ch
                db      "ExePack 4.05 by MicroSoft$$$$$", 0     ;; self checking :-(

                dd      2d000aa1h
                db      "AinEXE 2.1/2.2 (1994)$$$$$$$$$", 1

                dd      07160650h
                db      "Jam 2.11 (E.Vasilchenko/1991)$", 0

                dd      5001cebdh
                db      "ComPack 4.5 (Collins)$$$$$$$$$", 0

                dd      0c38ed38ch
                db      "ProPack 2.08 p p (1992)$$$$$$$", 0

                dd      1f0e1e50h
                db      "AVPack 1.22 (Andrei Volkov)$$$", 0             ;; ???

                dd      15d38cb8h
                db      "XPack 1.67/EXE(JauMing Tseng)$", 1
                dd      0E8EC8BFAh
                db      "XPack 1.67/COM(JauMing Tseng)$", 1

                dd      0cb8c061eh
                db      "XE 1.4.5b119 (2000)$$$$$$$$$$$", 0

                dd      05c2bcfch
                db      "AXE 2.2 (COM/EXE)$$$$$$$$$$$$$", 0     ;; 22.05.2002, rar

                dd      055D08EBh
                db      "ROSE SWE Reloc. Packer 0.01$$$", 1     ;; only relocs...
                ;; 25.06.2002
                dd      0be01b4cch
                db      "Crypt 1.3 by Dismember$$$$$$$$", 1     ;; no unpacker
                ;#   { changed/added 14.03.2006 21:19 by Ralph Roth  }
                      ;;"123456789o123456789o123456789o", x
                dd      0BF010DBEh
                db      "aPACK 0.98-0.99 [small,type2]$", 1     ;; no unpacker

                dd      0AD32C6E9h
                db      "Vlak/Program POSKOZEN!$$$$$$$$", 1

                dd      0C0E8061Eh;; 0C0E8061Eh
                db      "TraceLock 0.9$$$.$$$$$$$$$$$$$", 0     ;; 18.03.2006

                dd      0c88cfc06h
                db      "RJCrush 0.9,1.0,1.1++$$$$$$$$$", 0     ;; 18.03.2006

                dd      0C08CE88Bh
                db      "MS Exepack 3.69/Link$$$$$$$$$$", 0     ;; 22:33 20.03.2006

		dd	05E0100BFh
                db      "MicroXor/Joergen Ibsen/Jibz$$$", 1     ;; Donnerstag, 15. Mai 2008


;; WARNING: 0 marks the end of this table!
                dd      0,0,0,0,0,0,0
;;;------------------------------------------------------------------
CPDB_Found      db      "  Found: $"
CPDB_NoUnp      db      "Sorry NO Unpacker available!",13,10
		db	"  unROSE is unable to unpack this file!  :-(",7,13,10,"$"
CPDB_OKUnp      db      ". Internal Unpacker available! :-)",13,10,"$"
;;;------------------------------------------------------------------
CheckPackerDB:
        mov     edx, [dword es:bx]
        Mov     si, offset PackerDB
;;---loop---
cpdb_next:
        mov     eax, [dword cs:si]
        cmp     eax, 0
        jz      cpdb_ret
        add     si, 35
        cmp     eax, edx
        jnz     cpdb_next
        mov     al, [ byte cs:si-1]
        sub     si, 31

        PRINT   CPDB_Found
        PRINT   si
        cmp     al, 0
        jz      cpdb_ok
        ERROR   CPDB_NOUNP, 3           ;; rar, 14.05.2002, fixed!
        ret

cpdb_ok:
        PRINT   CPDB_OKUnp
        pop     ax                      ;; Return adress of call!!!
        jmp     @@ok1
cpdb_ret:
        ret
;;;------------------------------------------------------------------
@@KleeBauer:
        PRINT   KleeBauerFound
        jmp     @@ok1

@@ok_exom:
        PRINT   exomfound
        jmp     @@ok1

@@ok_APack:
        PRINT   APackFound
        jmp     @@ok1

@@Upx:
        PRINT   UPXFound1
        jmp     @@ok1
;;      exit    2
@@Upx1:
        PRINT   UPXFound2
        jmp     @@ok1

@@lglz:

        PRINT   LGLZFound
        jmp     @@ok1

@@PKliteFound:

        PRINT   PKliteFound
        jmp     @@ok1

@@ComprExe:

        PRINT   ComprExeFound
        jmp     @@ok1

@@ProtFound:
        PRINT   ProtectFound
        jmp     @@ok1

@@ProtEXE:
        Print   ProtEXEFound
        jmp     @@ok1

@@CryptLS:
        Print   CryptLSFound
        jmp     @@ok1

@@AinExe:
        Print   AInExeFound
        jmp     @@ok1

@@avpack:
        Print   AVPackFound
        jmp     @@ok1

@@netrun:
        Print   NetRunFound
        jmp     @@ok1

@@EliteCOM:
        Print   EliteFound
        jmp     @@ok1
@@ucexe:
        Print   UCExeFound
        jmp     @@ok1

@@ok_pr:
        Print   WWPackPrFound
        jmp     @@ok1
@@ok:
        PRINT   WWPackFound

;; --------------------------------------------------------------------------
;; Generic Return
;; --------------------------------------------------------------------------

@@ok1:
        pop     es
        POPAD
        ret

endp ChkPackType

;; -------------------------------------------------------------------------

proc    ChkProtect

        pusha
        mov     cx, 200
        mov     di, bx
        mov     [FoundProt], 0            ; not found yet :)
@@loop1:
        mov     al, 0e6h
        repne   scasb
        jcxz    @@ret
        cmp     [byte es:di], 021h
        jnz     @@loop1
        cmp     [byte es:di+1], 0e9h
        jz      @@found
        cmp     [byte es:di+1], 0ebh
        jnz     @@loop1
@@found:
        mov     [FoundProt], 1
@@ret:
        popa
        cmp     [FoundProt], 1
        ret

endp    ChkProtect


proc    ChkPklite
        push    di
        mov     di, bx
        mov     [FoundProt], 0
        cmp     [byte es:di], 50h
        jnz     @@noinc
        inc     di
@@noinc:
        cmp     [byte es:di], 0b8h
        jnz     @@ret
        cmp     [byte es:di+3], 0bah
        jnz     @@ret
        cmp     [byte es:di+6], 05h
        jz      @@found
        cmp     [byte es:di+6], 03bh
        jnz     @@ret
@@found:
        mov     [FoundProt], 1
@@ret:
        pop     di
        cmp     [FoundProt], 1
        ret
endp ChkPklite

;; End!
